import nkf
import term
import rect

def sc_sub(vp, vp2, t_l, p, l, sc):
	if vp < 0:
		n = -vp
		if p > 0:
			m = min(p, n)
			p -= m
			l += m
			sc -= m
			n -= m
		if n > 0 and p + l < t_l:
			m = min( t_l - (p + l), n )
			l += m
			sc -= m
			n -= m
		sc -= n
	if l < vp2:
		n = vp2 - l
		if p + l < t_l:
			m = min( t_l - (p + l), n )
			l += m
			n -= m
		if n > 0 and p > 0:
			m = min(p, n)
			p -= m
			l += m
			n -= m
		sc += n
	return (p, l, sc)

class Empty:
	pass

def new(r, nkf_opt):
	e = Empty()
	(t_w, t_h) = term.get_sz()
	(e.x, e.y) = term.get_pos()

	(rx, ry, rw, rh) = r

	(e.sx, e.sy) = (rx, ry)
	(e.w, e.h) = ( min(rw, t_w), min(rh, t_h) )

	sc = max( e.h - (t_h - e.y), 0 )
	if sc:
		term.scroll(sc)
		e.y -= sc
		
	to_view = lambda x, y: (x - e.sx, y - e.sy)
	view_to = lambda x, y: (x + e.sx, y + e.sy)

	def out(x, y, s):
		s = nkf.enc(s)
		if nkf_opt != '-u':
			s = nkf.cvt(s, nkf_opt)
		(x, y) = to_view(x, y)
		term.loc( x + e.x, y + e.y )
		term.out(s)
	e.out = out

	e.get_rect = lambda : rect.cvt_fxy( view_to, (0, 0, e.w, e.h) )

	def scroll(r):
		vr = rect.cvt_fxy( to_view, r )
		if rect.r_in_rect( vr, (0, 0, e.w, e.h) ):
			return r

		bak_p = rect.p_add( to_view( *rect.get_p(r) ), (e.x, e.y) )
		bak_sc = (e.sx, e.sy)

		(x, y, w, h) = r
		( (vx, vy), (vx2, vy2) ) = rect.to_p2(vr)

		(e.x, e.w, e.sx) = sc_sub(vx, vx2, t_w, e.x, e.w, e.sx)
		(e.y, e.h, e.sy) = sc_sub(vy, vy2, t_h, e.y, e.h, e.sy)

		all = e.get_rect()
		p = rect.p_add( to_view( *rect.get_p(r) ), (e.x, e.y) )
		if p == bak_p:
			if bak_sc[1] != e.sy:
				(ax, ay, aw, ah) = all
				(x, y, w, h) = r
				return (ax, y, aw, h)
			return r
		return all
	e.scroll = scroll

	e.fini = lambda : term.loc( 0, e.y + e.h )

	return e
# EOF
